﻿#target illustrator
#targetengine com.adobe.illustrator.demo.flashplayer

var swfFolder = Folder(Folder($.fileName).path + "");
var flashFile = new File(swfFolder.absoluteURI + "/" + "PI_FontList.swf");
var res =
"palette {\
	text:'PI_FontList',\
	properties:{ closeOnKey:'OSCmnd+W', resizeable:false},\
	fp: FlashPlayer {\
		preferredSize: [250, 600],\
		alignment: ['fill', 'fill']\
	},\
}";

var flashPanel = new Window (res);
flashPanel.margins = [0,0,0,0];
flashPanel.onClose = function(){ flashPanel = undefined;　}
flashPanel.fp.getOS = getOS; 
flashPanel.fp.getFonts = getFonts; 
flashPanel.fp.setFont = setFont;
flashPanel.fp.setValue = setValue;
flashPanel.fp.setValueRelative = setValueRelative;
flashPanel.show();
flashPanel.fp.loadMovie (flashFile);

/*----------------------------------------------------------------------*/

function getOS(){
	var s= app.path ; 
	return s;
}

/*----------------------------------------------------------------------*/


function getFonts (){
	var f = app.textFonts ; 
	var s = "";
	for( var i = 0 ; i < f.length ; i++ ){
		s += f[i].name 
		s += (i != f.length - 1)? ",":"";
	}
	return s;
}
 
		
/*----------------------------------------------------------------------*/

function setFont (_fontName){
	var bt = new BridgeTalk();
	bt.target = "illustrator";
	bt.body = "{\n" +
					"try{\n" +
					  "var _fontName = '"+_fontName+"';\n" +
					  "var sel = app.activeDocument.selection;\n" +
						"var font = app.textFonts.getByName(_fontName);\n" +
						"for( var i = 0 ; i < sel.length ; i++ ){\n" +
						"if(sel[i].toString()== '[TextFrame ]'){\n" +
						"for( var ii = 0 ; ii <sel[i].textRanges.length ; ii++ ){\n" +
						"sel[i].textRanges[ii].textFont = font\n" +
						"}\n" +
						"}\n" +
						"}\n" +
					"}catch (ex) {}\n" +
			"}\n";
	bt.onError = flashPanelBridgeTalkErrorHandler;
	bt.send();	
}

function setValue (_value){
	var bt = new BridgeTalk();
	bt.target = "illustrator";
	bt.body = "{\n" +
					"var _value = '"+_value+"';\n" +
					"var a =  _value.split(',')\n" +
					"var tar = a[0]\n" +
					"var val = a[1]\n" +
					"var sel = app.activeDocument.selection;\n" +
					"for( var i = 0 ; i < sel.length ; i++ ){\n" +
					"if(sel[i].toString()== '[TextFrame ]'){\n" +
					"for( var ii = 0 ; ii <sel[i].textRanges.length ; ii++ ){ \n" +
					"sel[i].textRanges[ii].characterAttributes[tar] = Number(val);\n" +
					"} \n" +
					"} \n" +
					"}\n" +
			"}\n";
	bt.onError = flashPanelBridgeTalkErrorHandler;
	bt.send();
}

function setValueRelative (_value){
	var bt = new BridgeTalk();
	bt.target = "illustrator";
	bt.body = "{\n" +
					"try{\n" +
					"var _value = '"+_value+"';\n" +
					"var a =  _value.split(',')\n" +
					"var tar = a[0]\n" +
					"var val = a[1]\n" +
					"var sel = app.activeDocument.selection;\n" +
					"for( var i = 0 ; i < sel.length ; i++ ){\n" +
					"if(sel[i].toString()== '[TextFrame ]'){\n" +
					"for( var ii = 0 ; ii <sel[i].textRanges.length ; ii++ ){ \n" +
					"sel[i].textRanges[ii].characterAttributes[tar] += Number(val);\n" +
					"} \n" +
					"} \n" +
					"}\n" +
					"}catch (ex) {}\n" +
			"}\n";
	bt.onError = flashPanelBridgeTalkErrorHandler;
	bt.send();
}


/*----------------------------------------------------------------------*/

function flashPanelBridgeTalkErrorHandler (btObj) {
	alert( btObj.body + " (" + btObj.headers ["Error-Code"] + ")" ); 
}
